<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<link rel="alternate"
      type="application/rss+xml"
      href="https://blog.winny.tech/rss.xml"
      title="RSS feed for https://blog.winny.tech/"/>
<title>blog.winny.tech</title>

<link href="static/style.css?v=1.13" rel="stylesheet" type="text/css" />
<meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<body>
<div id="preamble" class="status">
<nav>
<div class="flexcontainer">
<div class="smallitem">
<ul class="inline-list">
<li><a href=".">blog.winny.tech</a></li>
<li><a href="https://winny.tech/">About</a></li>
</ul>
</div>
<div class="bigitem">
<ul class="inline-list">
<li><a href="archive.html">Archive</a></li>
<li><a href="tags.html">Tags</a></li>
<li><a href="rss.xml">RSS Feed</a></li>
</ul>
</div>
</div>
</nav>
<hr/>
</div>
<div id="content">
<h1 class="title">Posts tagged "gentoo":</h1>
<div class="post-date">24 Apr 2020</div><h1 class="post-title"><a href="2020-04-24-debugging-zathura-gtk-dont-forget-about-seccomp.html">Debugging Zathura, GTK (don't forget about seccomp)</a></h1>
<p>
<a href="https://pwmt.org/projects/zathura/">Zathura</a> is a fantastic PDF viewer. It also supports Postscript, DjVu,
and Comicbook archive. In particular it supports using mupdf for the
backend, so it's rather fast (unlike poppler, used by evince and
friends). Here is a screenshot of Zathura:
</p>


<figure>
<img src="static/image/zathura.png" alt="zathura.png">

<figcaption><span class="figure-number">Figure 1: </span>screenshot of zathura</figcaption>
</figure>


<p>
Now that I've introduced Zathura. I want to talk about a problem I had
recently. I wanted to print a document a couple weeks ago, but found
whenever I issued a <code>:print</code> command in Zathura, the program would
crash. I got this error in dmesg:
</p>

<pre class="example">
[94592.482544] zathura[26424]: segfault at 201 ip 00007f0bc27d0086 sp 00007ffeada0d0d8 error 4 in libc-2.29.so[7f0bc2752000+158000]
[94592.482557] Code: 0f 1f 40 00 66 0f ef c0 66 0f ef c9 66 0f ef d2 66 0f ef db 48 89 f8 48 89 f9 48 81 e1 ff 0f 00 00 48 81 f9 cf 0f 00 00 77 6a &lt;f3&gt; 0f 6f 20 66 0f 74 e0 66 0f d7 d4 85 d2 74 04 0f bc c2 c3 48 83
</pre>

<div id="outline-container-orgffe9f1e" class="outline-2">
<h2 id="orgffe9f1e">Lets get a crash dump</h2>
<div class="outline-text-2" id="text-orgffe9f1e">
<p>
I spent a bunch of time trying to get crash dumps from Zathura,
and was largely unsuccessful, until I realized the wonkiness I was
dealing with (see below).
</p>
</div>


<div id="outline-container-org4921df0" class="outline-3">
<h3 id="org4921df0">Try to run Zathura in GDB</h3>
<div class="outline-text-3" id="text-org4921df0">
<p>
First I tried getting a backtrace directly from gdb. It appears to
run, but zathura does not create a window:
</p>

<pre class="example">
winston@snowcrash ~ $ gdb --args zathura ~/docs/uni/classes/cs-655/handouts/spim_documentation.pdf 
Reading symbols from zathura...
(gdb) run
Starting program: /usr/bin/zathura /home/winston/docs/uni/classes/cs-655/handouts/spim_documentation.pdf
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib64/libthread_db.so.1".
[New Thread 0x7ffff5f26700 (LWP 18882)]
[New Thread 0x7ffff5725700 (LWP 18883)]

Cannot find user-level thread for LWP 18744: generic error
(gdb)
</pre>

<p>
The error message <code>Cannot find user-level thread for LWP 18744:
   generic error</code> is <a href="https://sourceware.org/gdb/wiki/FAQ#GDB_reports_.22Cannot_find_user-level_thread_for_LWP_23957:_generic_error.22.2C_how_do_I_fix_this.3F">mentioned on the Sourceware Wiki</a>. The Wiki FAQ
suggests I may have a mismatch between <code>libthread_db.so.1</code> and
<code>libpthread.so.0</code> or am using a 64-bit debugger with a 32-bit
program. Both zathura and gdb are amd64 programs on my box. And I only
have one version of amd64 glibc installed. Given the facts, it seemed
like I was dealing with a different problem.
</p>

<p>
What's more is I tested running a program in <code>gdb</code>, in my case <code>cat</code>,
and it worked fine:
</p>

<pre class="example">
winston@snowcrash ~ $ gdb cat
Reading symbols from cat...
(gdb) run
Starting program: /bin/cat 
^C
Program received signal SIGINT, Interrupt.
0x00007ffff7eb5cb5 in __GI___libc_read (fd=0, buf=0x7ffff7fb0000, nbytes=131072) at ../sysdeps/unix/sysv/linux/read.c:26
26        return SYSCALL_CANCEL (read, fd, buf, nbytes);
</pre>
</div>
</div>

<div id="outline-container-org488d6dc" class="outline-3">
<h3 id="org488d6dc">Try to attach a Zathura process in GDB</h3>
<div class="outline-text-3" id="text-org488d6dc">
<p>
When attaching GDB to a process, make sure you have permission to do
so, out of the box most distros limit debuggers to either attach to
child processes or only if gdb is ran as root. In any case one can run
<code>sysctl kernel.yama.ptrace_scope=0</code> to temporarily loosen restrictions
to allow attaching gdb to any process of the same user. <a href="http://man7.org/linux/man-pages/man2/ptrace.2.html#NOTES">See
<code>ptrace(2)</code></a> and grep for <code>ptrace_scope</code>.
</p>

<p>
Now that gdb can attach to any other processes I own, I tried to
attach to zathura, without any success:
</p>

<pre class="example">
inston@snowcrash ~ $ gdb -p 3541 zathura
Reading symbols from zathura...
Attaching to program: /usr/bin/zathura, process 3541
ptrace: Operation not permitted.
(gdb) 
</pre>

<p>
Indeed this also worked fine with <code>cat</code>:
</p>

<pre class="example">
winston@snowcrash ~ $ gdb -p 6885 cat
Reading symbols from cat...
Attaching to program: /bin/cat, process 6885
Reading symbols from /lib64/libc.so.6...
Reading symbols from /usr/lib/debug//lib64/libc-2.29.so.debug...
Reading symbols from /lib64/ld-linux-x86-64.so.2...
Reading symbols from /usr/lib/debug//lib64/ld-2.29.so.debug...
0x00007f93b5fa4cb5 in __GI___libc_read (fd=0, buf=0x7f93b609f000, nbytes=131072) at ../sysdeps/unix/sysv/linux/read.c:26
26        return SYSCALL_CANCEL (read, fd, buf, nbytes);
(gdb) 
</pre>
</div>
</div>

<div id="outline-container-org6c78c02" class="outline-3">
<h3 id="org6c78c02">Try to get Zathura to dump core</h3>
<div class="outline-text-3" id="text-org6c78c02">
<p>
I moved on to the next approach to get a backtrace — write core
files. First I'll describe what that entails on my setup:
</p>
</div>

<div id="outline-container-org63e98fa" class="outline-4">
<h4 id="org63e98fa">Enabling core dumps</h4>
<div class="outline-text-4" id="text-org63e98fa">
<p>
On my setup, relatively vanilla Gentoo with OpenRC, it is
relatively straight forward to enable this — just create
<code>/etc/security/limits.d/core.conf</code> with the single line (see
<a href="http://man7.org/linux/man-pages/man5/limits.conf.5.html"><code>limits.conf(5)</code></a>):
</p>

<pre class="example">
*             soft      core       unlimited
</pre>

<p>
And relogin. Verify that the output of <code>ulimit -a</code> shows <code>unlimited</code>
core file size.
</p>

<pre class="example">
winston@snowcrash ~ $ ulimit -a
core file size          (blocks, -c) unlimited
data seg size           (kbytes, -d) unlimited
scheduling priority             (-e) 0
file size               (blocks, -f) unlimited
pending signals                 (-i) 63422
max locked memory       (kbytes, -l) 64
max memory size         (kbytes, -m) unlimited
open files                      (-n) 1024
pipe size            (512 bytes, -p) 8
POSIX message queues     (bytes, -q) 819200
real-time priority              (-r) 0
stack size              (kbytes, -s) 8192
cpu time               (seconds, -t) unlimited
max user processes              (-u) 63422
virtual memory          (kbytes, -v) unlimited
file locks                      (-x) unlimited
</pre>

<p>
The second part is ensuring <code>sysctl kernel.core_pattern</code> is set so
something reasonable. If it's a pipeline (first character is a
<code>|</code>), make sure you understand what that pipeline does, or set it
to a simple filename pattern. <a href="http://man7.org/linux/man-pages/man5/core.5.html">More information in <code>core(5)</code></a>. A
good file pattern might be <code>%e.%h.%t.core</code>, which produces core
files such as <code>cat.snowcrash.1586300242.core</code>. Time can be
converted into a human readable form with <code>date -d@1586300242</code>.
</p>

<pre class="example">
winston@snowcrash ~ $ sudo sysctl kernel.core_pattern=%e.%h.%t.core
kernel.core_pattern = %e.%h.%t.core
winston@snowcrash ~ $ cat
^\Quit (core dumped)
winston@snowcrash ~ $ ls *.core
cat.snowcrash.1586300242.core
winston@snowcrash ~ $ coretime() { date -d @"$(cut -d. -f3 &lt;&lt;&lt;"$1")"; }
winston@snowcrash ~ $ coretime cat.snowcrash.1586300242.core 
Tue 07 Apr 2020 05:57:22 PM CDT
</pre>
</div>
</div>

<div id="outline-container-org6ba4a3d" class="outline-4">
<h4 id="org6ba4a3d">Getting a core dump</h4>
<div class="outline-text-4" id="text-org6ba4a3d">
<p>
I fired up Zathura for what felt like the tenth time, and triggered
the bug, but indeed, no core dump! I even tried running zathura, and
instead sending SIGQUIT (<code>^\</code> — Control-Backslash in most terminals)
which should cause the process to dump core, but to no avail.
</p>

<p>
In the above shell session, I demonstrated that I was able to dump
core with <code>cat</code>, so indeed core dumps are enabled.
</p>
</div>
</div>
</div>

<div id="outline-container-org92b8945" class="outline-3">
<h3 id="org92b8945">Investigating why I can't get a crash dump</h3>
<div class="outline-text-3" id="text-org92b8945">
<p>
This feels like madness. There is no obvious reason why I can't get a
backtrace via any of the above techniques. So I took a deep breath, and
grabbed the source code, thinking they must be doing something a bit too
clever for my liking.
</p>
</div>

<div id="outline-container-org0141ef5" class="outline-4">
<h4 id="org0141ef5">Getting the source</h4>
<div class="outline-text-4" id="text-org0141ef5">
<p>
On Gentoo I usually do something like the following to grab program source:
</p>

<pre class="example">
winston@snowcrash ~ $ ebuild $(equery w zathura) prepare
 * zathura-0.4.5.tar.gz BLAKE2B SHA512 size ;-) ...                                                                     [ ok ]
 * checking ebuild checksums ;-) ...                                                                                    [ ok ]
 * checking miscfile checksums ;-) ...                                                                                  [ ok ]
&gt;&gt;&gt; Unpacking source...
&gt;&gt;&gt; Unpacking zathura-0.4.5.tar.gz to /var/tmp/portage/app-text/zathura-0.4.5/work
&gt;&gt;&gt; Source unpacked in /var/tmp/portage/app-text/zathura-0.4.5/work
&gt;&gt;&gt; Preparing source in /var/tmp/portage/app-text/zathura-0.4.5/work/zathura-0.4.5 ...
&gt;&gt;&gt; Source prepared.
</pre>
</div>
</div>

<div id="outline-container-org5e6b74d" class="outline-4">
<h4 id="org5e6b74d">Scanning the source</h4>
<div class="outline-text-4" id="text-org5e6b74d">
<p>
A quick scan of the source tree yields some most interesting
files — including some that will become more interesting as you
read on:
</p>

<pre class="example">
winston@snowcrash .../work/zathura-0.4.5 $ grep -riF ptrace .
./zathura/seccomp-filters.c:  /* prevent escape via ptrace */
./zathura/seccomp-filters.c:  DENY_RULE(ptrace);
./zathura/seccomp-filters.c:  /* prevent escape via ptrace */
</pre>

<p>
Notice the filename. It appears Zathura utilizes seccomp, and
somehow messes about with debuggers use of <code>ptrace()</code>. Here is a tree
of the files I'll be walking through:
</p>

<pre class="example">
winston@snowcrash .../work/zathura-0.4.5 $ tree -L 2 -F \
&gt; -P 'meson*|README|AUTHORS|LICENSE|main.[ch]|*seccomp*.[ch]|zathura.[ch]|config.[ch]'
.
├── AUTHORS
├── data/
│   ├── icon-128/
│   ├── icon-16/
│   ├── icon-256/
│   ├── icon-32/
│   ├── icon-64/
│   └── meson.build
├── doc/
│   ├── api/
│   ├── configuration/
│   ├── installation/
│   ├── man/
│   ├── meson.build
│   └── usage/
├── LICENSE
├── meson.build
├── meson_options.txt
├── po/
│   └── meson.build
├── README
├── subprojects/
├── tests/
│   └── meson.build
└── zathura/
    ├── config.c
    ├── config.h
    ├── main.c
    ├── seccomp-filters.c
    ├── seccomp-filters.h
    ├── zathura.c
    └── zathura.h

16 directories, 16 files
</pre>
</div>
</div>

<div id="outline-container-org5904f1b" class="outline-4">
<h4 id="org5904f1b">Where Seccomp is used in the code</h4>
<div class="outline-text-4" id="text-org5904f1b">
<p>
Indeed if we look in <code>seccomp-filters.c</code> it has a couple lines that suggest
zathura prevents dumping core &amp; using <code>ptrace()</code>:
</p>

<div class="org-src-container">
<pre class="src src-C"><span style="color: #919191;">#define</span> <span style="color: #ff1493;">ADD_RULE</span>(<span style="color: #ff69b4;">str_action</span>, <span style="color: #ff69b4;">action</span>, <span style="color: #ff69b4;">call</span>, ...)                                \
  <span style="color: #4c83ff;">do</span> {                                                                         \
    seccomp_rule_add(ctx, action, SCMP_SYS(call), __VA_ARGS__);                \
  } <span style="color: #4c83ff;">while</span> (0)

<span style="color: #919191;">#define</span> <span style="color: #ff1493;">DENY_RULE</span>(<span style="color: #ff69b4;">call</span>) ADD_RULE(<span style="color: #61CE3C;">"kill"</span>, SCMP_ACT_KILL, call, 0)

<span style="color: #afd8af;">int</span>
<span style="color: #ff1493;">seccomp_enable_basic_filter</span>(<span style="color: #afd8af;">void</span>)
{
  <span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">prevent escape via ptrace </span><span style="color: #8B8989; font-style: italic;">*/</span>
  <span style="color: #4c83ff;">if</span> (prctl(PR_SET_DUMPABLE, 0, 0, 0, 0)) {
    girara_error(<span style="color: #61CE3C;">"prctl PR_SET_DUMPABLE"</span>);
    <span style="color: #4c83ff;">return</span> -1;
  }
}
</pre>
</div>


<p>
Please note I tidied up the code for clarity. Looking in <code>prctl(2)</code>
we can see the <code>prctl(PR_SET_DUMPABLE, 0, 0, 0, 0)</code> not only
prevents core dumps, but prevents processes from attaching to
Zathura to debug it.
</p>

<p>
Now to figure out how it's called. Take a look at <code>zathura.c</code>.
</p>

<div class="org-src-container">
<pre class="src src-C"><span style="color: #afd8af;">bool</span>
<span style="color: #ff1493;">zathura_init</span>(<span style="color: #afd8af;">zathura_t</span>* <span style="color: #ff69b4;">zathura</span>)
{
<span style="color: #919191;">#ifdef</span> WITH_SECCOMP
  <span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">initialize seccomp filters </span><span style="color: #8B8989; font-style: italic;">*/</span>
  <span style="color: #4c83ff;">switch</span> (zathura-&gt;global.sandbox) {
    <span style="color: #4c83ff;">case</span> ZATHURA_SANDBOX_NONE:
      girara_debug(<span style="color: #61CE3C;">"Sandbox deactivated."</span>);
      <span style="color: #4c83ff;">break</span>;
    <span style="color: #4c83ff;">case</span> ZATHURA_SANDBOX_NORMAL:
      girara_debug(<span style="color: #61CE3C;">"Basic sandbox allowing normal operation."</span>);
      <span style="color: #4c83ff;">if</span> (seccomp_enable_basic_filter() != 0) {
        girara_error(<span style="color: #61CE3C;">"Failed to initialize basic seccomp filter."</span>);
        <span style="color: #4c83ff;">goto</span> <span style="color: #96CBFE;">error_free</span>;
      }
      <span style="color: #4c83ff;">break</span>;
    <span style="color: #4c83ff;">case</span> ZATHURA_SANDBOX_STRICT:
      girara_debug(<span style="color: #61CE3C;">"Strict sandbox preventing write and network access."</span>);
      <span style="color: #4c83ff;">if</span> (seccomp_enable_strict_filter() != 0) {
        girara_error(<span style="color: #61CE3C;">"Failed to initialize strict seccomp filter."</span>);
        <span style="color: #4c83ff;">goto</span> <span style="color: #96CBFE;">error_free</span>;
      }
      <span style="color: #4c83ff;">break</span>;
  }
<span style="color: #919191;">#endif</span>
}
</pre>
</div>

<p>
In the <code>zathura_init</code> procedure, seccomp is conditionally compiled
in using an an <code>#ifdef</code> check. It becomes apparent there are three
sandbox modes supported by Zathura. Next let's see where
<code>zathura_init()</code> is called in <code>main.c</code>:
</p>

<div class="org-src-container">
<pre class="src src-C"><span style="color: #4c83ff;">static</span> <span style="color: #afd8af;">zathura_t</span>*
<span style="color: #ff1493;">init_zathura</span>(<span style="color: #4c83ff;">const</span> <span style="color: #afd8af;">char</span>* <span style="color: #ff69b4;">config_dir</span>, <span style="color: #4c83ff;">const</span> <span style="color: #afd8af;">char</span>* <span style="color: #ff69b4;">data_dir</span>,
             <span style="color: #4c83ff;">const</span> <span style="color: #afd8af;">char</span>* <span style="color: #ff69b4;">cache_dir</span>, <span style="color: #4c83ff;">const</span> <span style="color: #afd8af;">char</span>* <span style="color: #ff69b4;">plugin_path</span>, <span style="color: #afd8af;">char</span>** <span style="color: #ff69b4;">argv</span>,
             <span style="color: #4c83ff;">const</span> <span style="color: #afd8af;">char</span>* <span style="color: #ff69b4;">synctex_editor</span>, <span style="color: #afd8af;">Window</span> <span style="color: #ff69b4;">embed</span>)
{
  <span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">create zathura session </span><span style="color: #8B8989; font-style: italic;">*/</span>
  <span style="color: #afd8af;">zathura_t</span>* <span style="color: #ff69b4;">zathura</span> = zathura_create();
  <span style="color: #4c83ff;">if</span> (zathura == <span style="color: #96CBFE;">NULL</span>) {
    <span style="color: #4c83ff;">return</span> <span style="color: #96CBFE;">NULL</span>;
  }

  <span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">Init zathura </span><span style="color: #8B8989; font-style: italic;">*/</span>
  <span style="color: #4c83ff;">if</span> (zathura_init(zathura) == <span style="color: #96CBFE;">false</span>) {
    zathura_free(zathura);
    <span style="color: #4c83ff;">return</span> <span style="color: #96CBFE;">NULL</span>;
  }

  <span style="color: #4c83ff;">return</span> zathura;
}

<span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">main function </span><span style="color: #8B8989; font-style: italic;">*/</span>
GIRARA_VISIBLE <span style="color: #afd8af;">int</span>
<span style="color: #ff1493;">main</span>(<span style="color: #afd8af;">int</span> <span style="color: #ff69b4;">argc</span>, <span style="color: #afd8af;">char</span>* <span style="color: #ff69b4;">argv</span>[])
{
  <span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">CLI parsing and initialization </span><span style="color: #8B8989; font-style: italic;">*/</span>

  <span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">Create zathura session </span><span style="color: #8B8989; font-style: italic;">*/</span>
  <span style="color: #afd8af;">zathura_t</span>* <span style="color: #ff69b4;">zathura</span> = init_zathura(config_dir, data_dir, cache_dir,
                                    plugin_path, argv, synctex_editor, embed);

  <span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">More initialization logic </span><span style="color: #8B8989; font-style: italic;">*/</span>

  <span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">run zathura </span><span style="color: #8B8989; font-style: italic;">*/</span>
  gtk_main();

  <span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">free zathura </span><span style="color: #8B8989; font-style: italic;">*/</span>
  <span style="color: #4c83ff;">return</span> ret;
}


</pre>
</div>

<p>
The program's entry point, <code>main()</code> calls <code>init_zathura()</code>, which
itself calls <code>zathura_init()</code>, and then calls into
<code>seccomp_enable_*_filter()</code>. This makes it clear that Zathura
always initializes sandboxing on startup, unless
<code>zathura-&gt;global.sandbox</code> is <code>ZATHURA_SANDBOX_NONE</code>.
</p>

<p>
If one looks in the top level <code>meson.build</code> we can see where the
<code>WITH_SECCOMP</code> proprocessor definition comes from:
</p>

<pre class="example">
if seccomp.found()
  build_dependencies += seccomp
  defines += '-DWITH_SECCOMP'
  additional_sources += files('zathura/seccomp-filters.c')
endif
</pre>

<p>
Now comes the matter how does one debug this application? Initially
I succeeded by configuring Gentoo to not use seccomp with
Zathura. After a second look, there appears to be a <code>sandbox</code>
configuration option. In the next few sections I explain how to
manually disable seccomp with both Gentoo USE flags, and by
configuring zathura at runtime.
</p>
</div>
</div>

<div id="outline-container-org2febd51" class="outline-4">
<h4 id="org2febd51">Disabling Seccomp by USE flag</h4>
<div class="outline-text-4" id="text-org2febd51">
<p>
Taking a closer look at the <code>app-text/zathura</code> package in Gentoo's
ebuild repository, there is a <code>seccomp</code> USE flag.
</p>

<pre class="example">
winston@snowcrash ~ $ eix -e app-text/zathura
[I] app-text/zathura
     Available versions:  0.4.3^t 0.4.4^t{tbz2} (~)0.4.5^t{tbz2} **9999*l^t {doc +magic seccomp sqlite synctex test}
     Installed versions:  0.4.5^t{tbz2}(05:21:00 PM 04/07/2020)(doc magic seccomp -sqlite -synctex -test)
     Homepage:            http://pwmt.org/projects/zathura/
     Description:         A highly customizable and functional document viewer
</pre>

<p>
Let's disable this <code>seccomp</code> USE flag:
</p>

<pre class="example">
snowcrash ~ # echo 'app-text/zathura -seccomp' &gt;&gt; /etc/portage/package.use/zathura
snowcrash ~ # emerge -1av app-text/zathura

These are the packages that would be merged, in order:

Calculating dependencies              ... done!                         
[ebuild   R   ~] app-text/zathura-0.4.5::gentoo  USE="doc magic -seccomp* -sqlite -synctex -test" 0 KiB

Total: 1 package (1 reinstall), Size of downloads: 0 KiB

Would you like to merge these packages? [Yes/No] 
</pre>


<p>
With Zathura rebuilt without seccomp support, I am able to attach
a debugger. Success!
</p>
</div>
</div>

<div id="outline-container-orga3484b5" class="outline-4">
<h4 id="orga3484b5">Disabling Seccomp via configuration option</h4>
<div class="outline-text-4" id="text-orga3484b5">
<p>
After reviewing zathura's configuration code, I found there is a
<code>sandbox</code> option that can be configured in one's zathurarc. It was
not mentioned in the <code>zathura(1)</code> manpage, nor its <code>--help</code>
text. I discovered it in the <code>README</code>. Later I also found it
mentioned in the <code>zathurarc(5)</code> manpage. As such, heed this
friendly reminder— make sure to read the <code>README</code>, and make sure to
read the related manpages in <code>SEE ALSO</code> section of a given
manpage!
</p>

<p>
Back to the matter at hand. Looking at <code>config.c</code>:
</p>

<div class="org-src-container">
<pre class="src src-C"><span style="color: #4c83ff;">static</span> <span style="color: #afd8af;">void</span>
<span style="color: #ff1493;">cb_sandbox_changed</span>(<span style="color: #afd8af;">girara_session_t</span>* <span style="color: #ff69b4;">session</span>, <span style="color: #4c83ff;">const</span> <span style="color: #afd8af;">char</span>* <span style="color: #ff1493;">UNUSED</span>(name),
                   <span style="color: #afd8af;">girara_setting_type_t</span> <span style="color: #ff1493;">UNUSED</span>(type), <span style="color: #4c83ff;">const</span> <span style="color: #afd8af;">void</span>* <span style="color: #ff69b4;">value</span>, <span style="color: #afd8af;">void</span>* <span style="color: #ff1493;">UNUSED</span>(data))
{
  g_return_if_fail(value != <span style="color: #96CBFE;">NULL</span>);
  g_return_if_fail(session != <span style="color: #96CBFE;">NULL</span>);
  g_return_if_fail(session-&gt;global.data != <span style="color: #96CBFE;">NULL</span>);
  <span style="color: #afd8af;">zathura_t</span>* <span style="color: #ff69b4;">zathura</span> = session-&gt;global.data;

  <span style="color: #4c83ff;">const</span> <span style="color: #afd8af;">char</span>* <span style="color: #ff69b4;">sandbox</span> = value;
  <span style="color: #4c83ff;">if</span> (g_strcmp0(sandbox, <span style="color: #61CE3C;">"none"</span>) == 0) {
    zathura-&gt;global.sandbox = ZATHURA_SANDBOX_NONE;
  } <span style="color: #4c83ff;">else</span> <span style="color: #4c83ff;">if</span> (g_strcmp0(sandbox, <span style="color: #61CE3C;">"normal"</span>) == 0)  {
    zathura-&gt;global.sandbox = ZATHURA_SANDBOX_NORMAL;
  } <span style="color: #4c83ff;">else</span> <span style="color: #4c83ff;">if</span> (g_strcmp0(sandbox, <span style="color: #61CE3C;">"strict"</span>) == 0) {
    zathura-&gt;global.sandbox = ZATHURA_SANDBOX_STRICT;
  } <span style="color: #4c83ff;">else</span> {
    girara_error(<span style="color: #61CE3C;">"Invalid sandbox option"</span>);
  }
}

<span style="color: #afd8af;">void</span>
<span style="color: #ff1493;">config_load_default</span>(<span style="color: #afd8af;">zathura_t</span>* <span style="color: #ff69b4;">zathura</span>)
{
  <span style="color: #afd8af;">girara_session_t</span>* <span style="color: #ff69b4;">gsession</span> = zathura-&gt;ui.session;

  <span style="color: #8B8989; font-style: italic;">/* </span><span style="color: #8B8989; font-style: italic;">default to no sandbox when running in WSL </span><span style="color: #8B8989; font-style: italic;">*/</span>
  <span style="color: #4c83ff;">const</span> <span style="color: #afd8af;">char</span>* <span style="color: #ff69b4;">string_value</span> = running_under_wsl() ? <span style="color: #61CE3C;">"none"</span> : <span style="color: #61CE3C;">"normal"</span>;
  girara_setting_add(gsession, <span style="color: #61CE3C;">"sandbox"</span>,
                     string_value, STRING, <span style="color: #96CBFE;">true</span>,
                     _(<span style="color: #61CE3C;">"Sandbox level"</span>), cb_sandbox_changed,
                     <span style="color: #96CBFE;">NULL</span>);
}
</pre>
</div>

<p>
Now we know there is an event listener for the <code>sandbox</code>
configuration option. I know I skipped a few steps, but the
pattern is pretty clear for my purposes. After adding <code>set sandbox
    none</code> to my <code>~/.config/zathura/config</code>, Zathura was able to start
up without a sandbox, and I was able to attach a debugger.
</p>
</div>
</div>
</div>

<div id="outline-container-orge22b469" class="outline-3">
<h3 id="orge22b469">Getting a more informative backtrace</h3>
<div class="outline-text-3" id="text-orge22b469">
<p>
Now, with seccomp disabled I was able to get a crash dump:
</p>

<pre class="example">
winston@snowcrash ~ $ gdb --args zathura ~/docs/uni/classes/cs-655/handouts/spim_documentation.pdf 
Reading symbols from zathura...
(gdb) run
Starting program: /usr/bin/zathura /home/winston/docs/uni/classes/cs-655/handouts/spim_documentation.pdf
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib64/libthread_db.so.1".
[New Thread 0x7ffff5f73700 (LWP 15633)]
[New Thread 0x7ffff5772700 (LWP 15634)]

(zathura:15629): dbind-WARNING **: 23:49:52.224: Couldn't register with accessibility bus: Did not receive a reply. Possible causes include: the remote application did not send a reply, the message bus security policy blocked the reply, the reply timeout expired, or the network connection was broken.
[New Thread 0x7fffe52b7700 (LWP 15639)]
[New Thread 0x7fffe4ab6700 (LWP 15645)]
[New Thread 0x7fffcbfff700 (LWP 15646)]

Thread 1 "zathura" received signal SIGSEGV, Segmentation fault.
__strlen_sse2 () at ../sysdeps/x86_64/multiarch/../strlen.S:120
120             movdqu  (%rax), %xmm4
(gdb) bt
#0  __strlen_sse2 () at ../sysdeps/x86_64/multiarch/../strlen.S:120
#1  0x00007ffff722753d in g_strjoinv () at /usr/lib64/libglib-2.0.so.0
#2  0x00007fffec65e31b in avahi_service_resolver_cb () at /usr/lib64/gtk-3.0/3.0.0/printbackends/libprintbackend-cups.so
#3  0x00007ffff73d4973 in g_task_return_now () at /usr/lib64/libgio-2.0.so.0
#4  0x00007ffff73d531d in g_task_return.part () at /usr/lib64/libgio-2.0.so.0
#5  0x00007ffff7429f0f in g_dbus_connection_call_done () at /usr/lib64/libgio-2.0.so.0
#6  0x00007ffff73d4973 in g_task_return_now () at /usr/lib64/libgio-2.0.so.0
#7  0x00007ffff73d49a9 in complete_in_idle_cb () at /usr/lib64/libgio-2.0.so.0
#8  0x00007ffff72064ef in g_main_context_dispatch () at /usr/lib64/libglib-2.0.so.0
#9  0x00007ffff72068c0 in g_main_context_iterate.isra () at /usr/lib64/libglib-2.0.so.0
#10 0x00007ffff7206bd3 in g_main_loop_run () at /usr/lib64/libglib-2.0.so.0
#11 0x00007ffff796a105 in gtk_main () at /usr/lib64/libgtk-3.so.0
#12 0x0000555555561871 in main ()
(gdb) frame 1
#1  0x00007ffff722753d in g_strjoinv () from /usr/lib64/libglib-2.0.so.0
(gdb) list
115     #ifdef AS_STRNLEN
116             andq    $-16, %rax
117             FIND_ZERO
118     #else
119             /* Test first 16 bytes unaligned.  */
120             movdqu  (%rax), %xmm4
121             PCMPEQ  %xmm0, %xmm4
122             pmovmskb        %xmm4, %edx
123             test    %edx, %edx
124             je      L(next48_bytes)
</pre>

<p>
Notice how the frame's listing shows assembly instructions. It
looks like we are missing debug symbols. Additionally, it would be
nice to have installed sources, because the debugger can show us
line-for-line backtraces and will make it easy to single-step
to the crash
</p>
</div>

<div id="outline-container-orge293f82" class="outline-4">
<h4 id="orge293f82">Installing debug symbols on Gentoo</h4>
<div class="outline-text-4" id="text-orge293f82">
<p>
On gentoo one can use <code>equery b</code> to discover what package owns a
particular file:
</p>

<pre class="example">
winston@snowcrash ~ $ for f in /usr/lib64/libglib-2.0.so.0 \
&gt; /usr/lib64/gtk-3.0/3.0.0/printbackends/libprintbackend-cups.so \
&gt; /usr/lib64/libgio-2.0.so.0 /usr/lib64/libglib-2.0.so.0 \
&gt; /usr/lib64/libgtk-3.so.0; do 
&gt;     equery -q b $f
&gt; done | sort -u
dev-libs/glib-2.60.7-r2
x11-libs/gtk+-3.24.13
</pre>

<p>
I came up with the following packages to install debug symbols for:
</p>

<ul class="org-ul">
<li><code>dev-libs/glib</code></li>
<li><code>x11-libs/gtk+:3</code></li>
<li>and <code>app-text/zathura</code> for good measure.</li>
</ul>


<p>
Using <a href="https://gitlab.com/winny-gentoo-ops/workstation-etc-portage/-/blob/master/env/debugsyms"><code>/etc/portage/env/debugsyms</code></a> and
<a href="https://gitlab.com/winny-gentoo-ops/workstation-etc-portage/-/blob/master/env/installsources"><code>/etc/portage/env/installsources</code></a> — Portage environment files
<a href="https://wiki.gentoo.org/wiki/Debugging">loosely based off the Gentoo Wiki</a> — I can simply add the following
lines to my <code>/etc/portage/package.env/</code>:
</p>

<pre class="example">
dev-libs/glib debugsyms installsources
x11-libs/gtk+:3 debugsyms installsources
app-text/zathura debugsyms installsources
</pre>

<p>
And then I manually re-emerged each package, because unfortunately
Portage does not appear to consider environment files when determining
when to rebuild packages.
</p>

<pre class="example">
snowcrash ~ # emerge -1av app-text/zathura dev-libs/glib x11-libs/gtk+:3

These are the packages that would be merged, in order:

Calculating dependencies           ... done!                    
[ebuild   R    ] dev-libs/glib-2.60.7-r2:2::gentoo  USE="dbus debug* (mime) xattr -fam -gtk-doc (-selinux) -static-libs -systemtap -test -utils" ABI_X86="32 (64) (-x32)" 0 KiB
[ebuild   R    ] x11-libs/gtk+-3.24.13:3::gentoo  USE="X cups examples introspection xinerama (-aqua) -broadway -cloudprint -colord -gtk-doc -test -vim-syntax -wayland" ABI_X86="(64) -32 (-x32)" 0 KiB
[ebuild   R   ~] app-text/zathura-0.4.5::gentoo  USE="doc magic -seccomp -sqlite -synctex -test" 0 KiB

Total: 3 packages (3 reinstalls), Size of downloads: 0 KiB

Would you like to merge these packages? [Yes/No] 
</pre>

<p>
Portage installed the source code under <code>/usr/src/debug/${CATEGORY}/${PF}</code>,
where <a href="https://dev.gentoo.org/~zmedico/portage/doc/man/ebuild.5.html#lbAF"><code>PF</code> is the full package name, version, and revision</a>, such
as <code>/usr/src/debug/x11-base/xorg-server-1.20.5-r2</code>. Debug symbols
will be installed under <code>/usr/lib/debug</code>.
</p>
</div>
</div>

<div id="outline-container-org125f60a" class="outline-4">
<h4 id="org125f60a">A better backtrace</h4>
<div class="outline-text-4" id="text-org125f60a">
<p>
After getting the debug symbols &amp; sources installed, I now get the
following backtrace:
</p>

<pre class="example">
winston@snowcrash ~ $ gdb --args zathura ~/docs/uni/classes/cs-655/handouts/spim_documentation.pdf 
Reading symbols from zathura...
Reading symbols from /usr/lib/debug//usr/bin/zathura.debug...
(gdb) run
Starting program: /usr/bin/zathura /home/winston/docs/uni/classes/cs-655/handouts/spim_documentation.pdf
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib64/libthread_db.so.1".
[New Thread 0x7ffff5f62700 (LWP 12321)]
[New Thread 0x7ffff5761700 (LWP 12322)]
[New Thread 0x7fffe52b7700 (LWP 12329)]
[New Thread 0x7fffe4ab6700 (LWP 12333)]
[New Thread 0x7fffcbfff700 (LWP 12334)]

Thread 1 "zathura" received signal SIGSEGV, Segmentation fault.
__strlen_sse2 () at ../sysdeps/x86_64/multiarch/../strlen.S:120
120             movdqu  (%rax), %xmm4
(gdb) bt
#0  __strlen_sse2 () at ../sysdeps/x86_64/multiarch/../strlen.S:120
#1  0x00007ffff721680d in g_strjoinv (separator=separator@entry=0x7fffec702546 "-", str_array=str_array@entry=0x555555e56ac0)
    at ../glib-2.60.7/glib/gstrfuncs.c:2585
#2  0x00007fffec6fd31b in avahi_service_resolver_cb
    (source_object=&lt;optimized out&gt;, res=&lt;optimized out&gt;, user_data=user_data@entry=0x555555e06040)
    at /usr/src/debug/x11-libs/gtk+-3.24.13/gtk+-3.24.13/modules/printbackends/cups/gtkprintbackendcups.c:3223
#3  0x00007ffff73caf79 in g_task_return_now (task=0x555555ea01a0 [GTask]) at ../glib-2.60.7/gio/gtask.c:1209
#4  0x00007ffff73cba9d in g_task_return (task=0x555555ea01a0 [GTask], type=&lt;optimized out&gt;) at ../glib-2.60.7/gio/gtask.c:1278
#5  0x00007ffff73cc00c in g_task_return (type=G_TASK_RETURN_SUCCESS, task=&lt;optimized out&gt;) at ../glib-2.60.7/gio/gtask.c:1678
#6  g_task_return_pointer (task=&lt;optimized out&gt;, result=&lt;optimized out&gt;, result_destroy=&lt;optimized out&gt;)
    at ../glib-2.60.7/gio/gtask.c:1683
#7  0x0000000000000000 in  ()
</pre>

<p>
If you feel inclined, <a href="https://gitlab.com/snippets/1963993">here is the full backtrace (<code>bt full</code>)</a>.
</p>

<p>
A lot more useful, huh?
</p>
</div>
</div>
</div>
</div>

<div id="outline-container-org5d68689" class="outline-2">
<h2 id="org5d68689">Analyzing the crash</h2>
<div class="outline-text-2" id="text-org5d68689">
<p>
Knowing GDB is a powerful, useful skill. Nothing beats understanding
your debugger. Not even printf debugging.
</p>

<p>
Let's start with the source of the crash:
</p>

<pre class="example">
(gdb) frame 0
#0  __strlen_sse2 () at ../sysdeps/x86_64/multiarch/../strlen.S:120
120             movdqu  (%rax), %xmm4
(gdb) list
115     #ifdef AS_STRNLEN
116             andq    $-16, %rax
117             FIND_ZERO
118     #else
119             /* Test first 16 bytes unaligned.  */
120             movdqu  (%rax), %xmm4
121             PCMPEQ  %xmm0, %xmm4
122             pmovmskb        %xmm4, %edx
123             test    %edx, %edx
124             je      L(next48_bytes)
(gdb) info registers rax
rax            0x61                97
</pre>

<p>
So strlen is trying to derefence address <code>0x61</code>, that doesn't look
right. Cheking the output of <code>info proc mappings</code> shows zathura
doesn't have mapped memory that corresponds to the value in <code>rax</code>.
</p>

<pre class="example">
(gdb) info proc mappings
process 12314                                                                                                                  
Mapped address spaces:                                                                                                         

          Start Addr           End Addr       Size     Offset objfile                                                          
      0x555555554000     0x55555555f000     0xb000        0x0 /usr/bin/zathura                                                 
      0x55555555f000     0x555555581000    0x22000     0xb000 /usr/bin/zathura                                                 

…SNIP…

      0x7ffff7ffd000     0x7ffff7ffe000     0x1000    0x27000 /lib64/ld-2.29.so
      0x7ffff7ffe000     0x7ffff7fff000     0x1000        0x0 
      0x7ffffffdd000     0x7ffffffff000    0x22000        0x0 [stack]
  0xffffffffff600000 0xffffffffff601000     0x1000        0x0 [vsyscall]

</pre>

<p>
Now let's carry on with the second frame.
</p>

<pre class="example">
(gdb) frame 1
#1  0x00007ffff721680d in g_strjoinv (separator=separator@entry=0x7fffec702546 "-", str_array=str_array@entry=0x555555e56ac0)
    at ../glib-2.60.7/glib/gstrfuncs.c:2585
2585          for (i = 1; str_array[i] != NULL; i++)
(gdb) info frame
Stack level 1, frame at 0x7fffffffd140:
 rip = 0x7ffff721680d in g_strjoinv (../glib-2.60.7/glib/gstrfuncs.c:2585); saved rip = 0x7fffec6fd31b
 called by frame at 0x7fffffffd200, caller of frame at 0x7fffffffd0f0
 source language c.
 Arglist at 0x7fffffffd0e8, args: separator=separator@entry=0x7fffec702546 "-", str_array=str_array@entry=0x555555e56ac0
 Locals at 0x7fffffffd0e8, Previous frame's sp is 0x7fffffffd140
 Saved registers:
  rbx at 0x7fffffffd108, rbp at 0x7fffffffd110, r12 at 0x7fffffffd118, r13 at 0x7fffffffd120, r14 at 0x7fffffffd128,
  r15 at 0x7fffffffd130, rip at 0x7fffffffd138
(gdb) list
2580          gsize separator_len;
2581
2582          separator_len = strlen (separator);
2583          /* First part, getting length */
2584          len = 1 + strlen (str_array[0]);
2585          for (i = 1; str_array[i] != NULL; i++)
2586            len += strlen (str_array[i]);
2587          len += separator_len * (i - 1);
2588
2589          /* Second part, building string */
(gdb) print *str_array
$1 = (gchar *) 0x555555cea670 "Canon"
(gdb) print str_array[1]
$2 = (gchar *) 0x555555dac870 "MF632C"
(gdb) print str_array[2]
$3 = (gchar *) 0x555555e87150 "634C"
(gdb) print str_array[3]
$4 = (gchar *) 0x61 &lt;error: Cannot access memory at address 0x61&gt;
</pre>

<p>
Indeed, we cannot access memory of address <code>0x61</code>. And looking at the
source and documentation for g<sub>strjoinv</sub>, the <code>str_array</code> argument
should be a NUL terminated array of strings.
</p>

<p>
Let's look at the third frame.
</p>

<pre class="example">
(gdb) frame 2
#2  0x00007fffec6fd31b in avahi_service_resolver_cb (source_object=&lt;optimized out&gt;, res=&lt;optimized out&gt;, 
    user_data=user_data@entry=0x555555e06040)
    at /usr/src/debug/x11-libs/gtk+-3.24.13/gtk+-3.24.13/modules/printbackends/cups/gtkprintbackendcups.c:3223
3223                  data-&gt;printer_name = g_strjoinv ("-", printer_name_compressed_strv);
(gdb) info frame
Stack level 2, frame at 0x7fffffffd200:
 rip = 0x7fffec6fd31b in avahi_service_resolver_cb
    (/usr/src/debug/x11-libs/gtk+-3.24.13/gtk+-3.24.13/modules/printbackends/cups/gtkprintbackendcups.c:3223); 
    saved rip = 0x7ffff73caf79
 called by frame at 0x7fffffffd220, caller of frame at 0x7fffffffd140
 source language c.
 Arglist at 0x7fffffffd138, args: source_object=&lt;optimized out&gt;, res=&lt;optimized out&gt;, user_data=user_data@entry=0x555555e06040
 Locals at 0x7fffffffd138, Previous frame's sp is 0x7fffffffd200
 Saved registers:
  rbx at 0x7fffffffd1c8, rbp at 0x7fffffffd1d0, r12 at 0x7fffffffd1d8, r13 at 0x7fffffffd1e0, r14 at 0x7fffffffd1e8,
  r15 at 0x7fffffffd1f0, rip at 0x7fffffffd1f8
(gdb) list
3218                          printer_name_compressed_strv[j] = printer_name_strv[i];
3219                          j++;
3220                        }
3221                    }
3222
3223                  data-&gt;printer_name = g_strjoinv ("-", printer_name_compressed_strv);
3224
3225                  g_strfreev (printer_name_strv);
3226                  g_free (printer_name_compressed_strv);
3227                  g_free (printer_name);
(gdb) print printer_name_compressed_strv 
$5 = (gchar **) 0x555555e56ac0
</pre>

<p>
Note the value of <code>printer_name_compressed_strv</code> of <code>0x555555e56ac0</code>
corresponds to the value of <code>str_array</code> in the previous frame
(<code>g_strjoinv()</code>). The full definition of <code>avahi_sernvice_resolver_cb</code>
can be read on Gnome's GitLab.
</p>

<p>
As mentioned above, we found the sentinel value of the string array
was not NUL. Looking at the following code, do you see the bug? I
honestly didn't:
</p>

<div class="org-src-container">
<pre class="src src-C">printer_name = g_strdup (name);
<span style="color: #ff1493;">g_strcanon</span> (printer_name, PRINTER_NAME_ALLOWED_CHARACTERS, <span style="color: #61CE3C;">'-'</span>);

printer_name_strv = g_strsplit_set (printer_name, <span style="color: #61CE3C;">"-"</span>, -1);
printer_name_compressed_strv = g_new0 (<span style="color: #afd8af;">gchar</span> *, g_strv_length (printer_name_strv));
<span style="color: #4c83ff;">for</span> (i = 0, j = 0; <span style="color: #afd8af;">printer_name_strv</span>[i] != <span style="color: #96CBFE;">NULL</span>; i++)
  {
    <span style="color: #4c83ff;">if</span> (printer_name_strv[i][0] != <span style="color: #61CE3C;">'\0'</span>)
      {
        printer_name_compressed_strv[j] = printer_name_strv[i];
        j++;
      }
  }

data-&gt;printer_name = g_strjoinv (<span style="color: #61CE3C;">"-"</span>, printer_name_compressed_strv);
</pre>
</div>

<p>
After spending some time refamiliarizing myself with glib, GTK+, and
Googling, it became apparently after I found the commit that fixed
it. Let me preface the found commit with a brief explaination.
</p>

<ol class="org-ol">
<li><code>g_strcanon()</code> replaces characters not in
<code>PRINTER_NAME_ALLOW_CHARACTERS</code> with a hyphen, i.e. <code>"Canon
   MF632C/634C"</code> becomes <code>"Canon-MF632C-634C"</code></li>
<li><p>
<code>g_strsplit_set()</code> splits <code>printer_name</code> on <code>"-"</code>, giving the
following array: 
</p>
<pre class="example">
(gdb) print *printer_name_strv@g_strv_length(printer_name_strv)+1
$12 = {0x555555eff250 "Canon", 0x555555ece120 "MF632C", 0x555555f397e0 "634C", 0x0}
</pre></li>
<li><code>g_new0()</code> initializes a zero-filled array of pointers of length 3,
the number of splitted elements returned by <code>g_strsplit_set()</code></li>
<li>The for loop copies over the contents of printer<sub>name</sub><sub>strv</sub>, but
skips empty elements - e.g. in the case that the above string had
two adjacent hypens.</li>
<li>The <code>g_strjoinv()</code> joins each string in the
<code>printer_name_compressed_strv</code> array of strings, joining them on
<code>"-"</code>.</li>
</ol>

<p>
The problem occurs because the call to <code>g_new0</code> does not account for
the extra array sentinel element. <a href="https://gitlab.gnome.org/GNOME/gtk/-/commit/3d5f083b75a0c2b50fb5528a19e0e095e85a438e">Indeed that is what the GitLab
commit discusses.</a>
</p>
</div>
</div>

<div id="outline-container-orgfc9d5ea" class="outline-2">
<h2 id="orgfc9d5ea">Best way to fix it?</h2>
<div class="outline-text-2" id="text-orgfc9d5ea">
<p>
In this case, I did what is best for my time effort. GTK+ 3.24.14
has been out for a couple months, and GTK+ 3.24.13 is not much
older. So instead of dealing with backports, that is making a patch
for the older version of GTK+ and adding it to my install, I took
the liberty to bump my local GTK+ 3 install to GTK+ 3.24.14.
</p>

<p>
Either is not too tricky, in all honesty, given adding patches to a
Gentoo system is as easy as placing the patch in the correct
path. And bumping the ebuild usually entails simply unmasking it via
accepting the keyworded version (in my case <code>~amd64</code>).
</p>

<p>
As such this is all I had to do to fix the issue:
</p>

<pre class="example">
snowcrash ~ # echo '~x11-libs/gtk+-3.24.14 ~amd64' &gt;&gt; /etc/portage/package.accept_keywords/gtk
snowcrash ~ # emerge -uDU -av --changed-deps --verbose-conflicts @world

These are the packages that would be merged, in order:



[ebuild     U ~] x11-libs/gtk+-3.24.14:3::gentoo [3.24.13:3::gentoo] USE="X cups examples introspection xinerama (-aqua) -broadway -cloudprint -colord -gtk-doc -test -vim-syntax -wayland" ABI_X86="(64) -32 (-x32)" 0 KiB

Total: 1 package (1 upgrade), Size of downloads: 0 KiB

Would you like to merge these packages? [Yes/No] 
</pre>

<p>
And viola. I am able to print!
</p>


<figure>
<img src="static/image/print-success.png" alt="print-success.png">

<figcaption><span class="figure-number">Figure 2: </span>gtk print dialogue success!</figcaption>
</figure>
</div>
</div>


<div id="outline-container-org746c292" class="outline-2">
<h2 id="org746c292">Conclusion</h2>
<div class="outline-text-2" id="text-org746c292">
<p>
In this post, I described several related challenges:
</p>

<ol class="org-ol">
<li>How to get a backtrace</li>
<li>What happens when seccomp blocks ptrace</li>
<li>How to install debug symbols and source code on Gentoo</li>
<li>What it looks like to pick apart a backtrace</li>
<li>And how I fixed this particular issue</li>
</ol>

<p>
In retrospect, I should have reported the bug to the gentoo tracker,
because this was a bug due to the selection of patches cherry picked
off the gtk git repository. Thankfully the affected versions of GTK
are no longer in the official gentoo ebuild repository. I'll be sure
to report such bugs going forward! It pleases me how easy Gentoo
makes it to debug stuff.
</p>

<p>
I found the entire experience here informative, but also incredibly
irritating. I'm no stranger to debugging crashes and grabbing debug
symbols. When something gets in the way of getting backtraces,
things really get very frustrating. The debugging part is the fun
part; dealing with wildcards like seccomp preventing <code>ptrace()</code> with
no meaningful error messages is a huge time waster.
</p>

<p>
The lack of literature about debugging seccomp enabled applications
was a factor in this frustration. I only figured out the issue due
to taking the time to read the source code, grepping for ptrace, and
understanding seccomp as its used in Zathura. Had I read the README
I could have saved some time; It's important to read all the
documentation.
</p>

<p>
If you made it this far, you have a lot of patience for ramblings
and hobbyist computing. You're terrific! Next time you run into a
segfault, put what you've learned to good use!
</p>
</div>
</div>
<div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-gentoo.html">gentoo</a> <a href="tag-computing.html">computing</a> </div>
<div class="post-date">18 Apr 2020</div><h1 class="post-title"><a href="2020-04-18-a-week-in-the-life-of-winston.html">A week in the life of Winston</a></h1>
<p>
During these interesting times, I figure it would be a good idea to
describe how I've been keeping myself busy, bugs I've fixed, and some
of the daily tasks/routines that keep my day structured.
</p>

<p>
For context: I moved house on the weekend of March 21st, which is a
couple weeks before the Covid-19 fiasco became a front-and-center
concern for my geographical region. I am finishing my undergrad in
computer science — this is my last semester. The classes I am taking
are Compilers, Compiler Implementation Laboratory, and Matrices and
Applications. I am now currently living in a very rural area, so I
have been very successful in maintaining a social distance in all
aspects of my life.
</p>

<div id="outline-container-org8ac52c8" class="outline-2">
<h2 id="org8ac52c8">Daily routine</h2>
<div class="outline-text-2" id="text-org8ac52c8">
<ol class="org-ol">
<li>Eat the exact same thing every day: Eggs, Bacon, Corn
Tortillas. Take any dietary supplements/vitamins.</li>
<li>Make coffee — Aeropressed. Currently sourcing coffee from
<a href="https://rubycoffeeroasters.com/">Ruby</a>. I wish to see more Ethiopia/Kenya/Peru coffee but even a
more earthy Colombia coffee is agreeable.</li>
<li>Spend 30–60 minutes checking email, news, IRC.</li>
<li>Wash up</li>
<li>Spend about 2-3 hours on current tasks — schoolwork, bugfixing,
packaging, or researching.</li>
<li>Eat a lunch, make some tea</li>
<li>Spend another 2-3 hours on same tasks.</li>
<li>Take a break, preferably away from computer</li>
<li>Spend another couple hours</li>
<li>Have a dinner</li>
<li>Spend some time with housemates, make sure we're all on the same page</li>
<li>Spend another couple hours on tasks</li>
<li>Wash up, goto bed</li>
</ol>

<p>
In retrospect, I think I should replace one of those task blocks
with off-task things such as gaming, reading books, and so
on. That's way too much time on task, and knowing myself I end up
being less productive due to too much time on task.
</p>
</div>
</div>

<div id="outline-container-orgab540ee" class="outline-2">
<h2 id="orgab540ee">Package work for this week</h2>
<div class="outline-text-2" id="text-orgab540ee">
<p>
For a long time now, I've aimed to keep all my system-wide software
packaged in the OS package manager. This allows me to easily rebuild
my systems, or deploy the OS on new computers. This also means
updates become a lot easier, because the package manager can track
things such as rebuilding all library dependencies, and ensuring
dependencies are installed and are the correct versions. Depending
on your OS it's pretty easy. In my case Gentoo makes it extremely
easy.
</p>
</div>

<div id="outline-container-org93a287c" class="outline-3">
<h3 id="org93a287c">Alephone</h3>
<div class="outline-text-3" id="text-org93a287c">
<p>
I reintroduced <a href="https://gpo.zugaina.org/Search?search=alephone">Alephone packages</a><sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup> to play the classic Bungie first
person shooters Marathon, Marathon 2: Durandal, and Marathon 3:
Infinity. Thankfully I could base some of my work off my <a href="https://bitbucket.org/winny-/srsbuilds/src/default/games-fps/">old Portage
overlay</a> combined with <a href="https://github.com/gentoo/gentoo/search?q=games-fps%2Falephone&amp;type=Commits">couple-year-old commits</a> from the official
Gentoo repository.
</p>

<p>
After getting a show-stopping bug addressed, I added a prerelease
package that includes fixes that should address memory corruption,
flickering sprites, and (some of the) popping audio. See details in the
Bugs Addressed section.
</p>
</div>
</div>

<div id="outline-container-orgc266e0b" class="outline-3">
<h3 id="orgc266e0b">The toolchain used for my university course</h3>
<div class="outline-text-3" id="text-orgc266e0b">
<p>
An ongoing desire was to do all my university homeworks locally,
without logging into servers with less software choice, and an
abnormal amount of network jitter/latency spikes. I finally made it
happen with a combination of rsync invocations followed by a <code>tar
   -czvf</code> and a <a href="https://gpo.zugaina.org/dev-lang/uwm-cool-bin">Gentoo package</a>.
</p>

<p>
I find this very exciting. I invest very heavily into my computer
environment, and try my best to avoid doing complicated work in
unfamiliar environments. I can also do work offline now.
</p>

<p>
It is worth noting that the distfiles for this package are not
publicly available, and as such you will have be a student in the
course to install it. This is intentional. I have zero interest in
trying to make this toolchain public or open source, I merely want
to use it locally.
</p>
</div>
</div>
</div>

<div id="outline-container-org9acfb84" class="outline-2">
<h2 id="org9acfb84">Bugs addressed</h2>
<div class="outline-text-2" id="text-org9acfb84">
</div>
<div id="outline-container-org0e1a556" class="outline-3">
<h3 id="org0e1a556">Deal with issue making Emacs unresponsive</h3>
<div class="outline-text-3" id="text-org0e1a556">
<p>
I am pleased to <a href="https://github.com/robert-zaremba/auto-virtualenvwrapper.el/pull/9">discover and fix a longstanding bug</a> that would
yield my Emacs unresponsive after visiting files, then deleting the
directories the visited files resided in. I wish I had documented
the first time I noticed this problem; it may have been as soon as
I introduced <code>auto-virtualenvwrapper</code> to my workflow. This package
tells Emacs to automatically search for Python virtualenvs for use
in ansi-term (terminal in emacs), running python code from emacs,
and getting accurate tab completion when writing python.
</p>

<p>
This was one of those sort of irksome issues that is difficult to
debug unless one invests effort to reconfigure emacs to report
error traces, which can't be set after the bug occurs. As a result
every time I've encountered this bug, I have given up, and simply
restarted Emacs daemon, because messing up the minibuffer precludes
issuing a <code>M-x toggle-debug-on-error RET</code>.
</p>

<p>
I want to thank the maintainer of auto-pythonvirtualenv for being
very responsive to pull request I made. Contributing to Emacs
packages is a lot of hit-or-miss, because it seems some of the less
commonly used Emacs packages are dead. Additionally there is a
culture of disinterest in accepting PRs that don't directly improve
the maintainer's quality of life.
</p>
</div>
</div>

<div id="outline-container-org39be70e" class="outline-3">
<h3 id="org39be70e">Strange Alephone memory corruption</h3>
<div class="outline-text-3" id="text-org39be70e">
<p>
I was very excited to get Alephone packaged and installed. I
started noting weirdness on my workstation setup. It started with
some graphics corruption, with sprites being rotated 90°, and
severe visual corruption when interacting with the in-game text
terminals. Invariably on every exit the game segfaults with
<a href="https://stackoverflow.com/a/53907212/2720026"><code>corrupted size vs. prev_size</code></a>.
</p>

<p>
<a href="https://github.com/Aleph-One-Marathon/alephone/issues/181">I reported the issue</a>, and after a lot of testing, it become
apparent the issue only occurs when playing at my native
resolution, which is 1440p (2560×1440), but does not happen at
1080p (1920×1080). Thanks to my (over) comprehensive testing and a
couple passionate project maintainers, someone was able to pinpoint
the source of the bug was due to an out of bounds write. The writes
was caused by a statically allocated buffer used to copy artifacts
of the render trees onto the screen. Or something like that.
</p>

<p>
I wrote a quick and dirty patch, then later one of the maintainers
helped write a more future-proof patch. After testing it appears
the problem is fixed. This was a fantastic experience, the
discussion was on topic, there was no bike shedding, and everybody
treated each other with kindness.
</p>
</div>
</div>
</div>

<div id="outline-container-orgbc88ad8" class="outline-2">
<h2 id="orgbc88ad8">Dropping Nvidia</h2>
<div class="outline-text-2" id="text-orgbc88ad8">
<p>
In 2015 I purchased a Nvidia GTX 760 used for $50. It was a great
investment. At the time AMD driver quality is pretty poor. This is
the post-fglrx horror years, but the drivers were still subpar
compared to Nvidia's proprietary drivers. You could not expect to
get Windows-par graphics performance on an AMD card in 2015. On the
other hand one could expect Windows-par graphics performance on a
Nvidia card.
</p>
</div>

<div id="outline-container-org36cd18b" class="outline-3">
<h3 id="org36cd18b">Why AMD and not Nvidia</h3>
<div class="outline-text-3" id="text-org36cd18b">
<p>
The landscape has completely changed in the last 5 years. AMD has
open sourced their graphics drivers, and is actively helping out in
maintaining them. Nvidia on the other hand has inherit issues such
as
</p>
<ul class="org-ul">
<li>upgrading the driver breaks currently running Xorg sessions'
3d acceleration, and requires a reboot;</li>
<li>Out of tree kernel drivers are usually a bad idea, though I
appreciate <a href="https://wiki.gentoo.org/wiki/Kernel/Upgrade#Reinstalling_external_kernel_modules">how easy Gentoo makes it to deal with them</a> — simply run
<code>emerge @module-rebuild</code>, this still a mild annoyance because it
adds extra steps when upgrading kernels or rebuilding kernels</li>
<li>No <a href="https://wiki.archlinux.org/index.php/Kernel_mode_setting">native resolution modesetting is available on Nvidia</a>, so your
linux consoles (tt1-tty6 on most installs) are stuck at a very low
resolution, and look very chunky;</li>
<li><del>you have to either use Nvidia libGL or use Mesa, not both</del>
(<a href="https://gitlab.freedesktop.org/glvnd/libglvnd">libglvnd</a> fixes this apparently);</li>
<li>it's yet another non-free software to install on my computer — if
bugs occur I cannot contribute fixes, or solicit fixes from other
users</li>
<li>OBS acts up with Nvidia binary drivers, GZdoom skyboxes are not
captured, and certain 3d applications are somewhat difficult to
capture correctly with the binary drivers;</li>
<li>Nvidia's composition pipeline feature for reducing video tearing
is pretty awful. <a href="https://www.reddit.com/r/linux_gaming/comments/5tym3e/nvidia_linux_tearing_and_forcecompositionpipeline/">It simply makes most animations look
choppy/stuttery</a>, and ruins the experience of most video playback;</li>
<li>Nvidia is liable to drop support for my card in another year or
so, forcing me to upgrade anyways, <a href="https://www.nvidia.com/en-us/drivers/unix/legacy-gpu/">this is planned obsolescence at
the driver level</a>. With AMD on the other hand the driver probably
will stay in tree and supported for a couple decades;</li>
<li>There is no way to track resource usage of my GPU — it's too old
to support tracking resource usage in <code>nvidia-smi</code>, but <a href="https://github.com/clbr/radeontop"><code>radeontop</code></a>
has been able to do this on all AMD cards for a very long time;</li>
<li>and there <a href="https://gitlab.freedesktop.org/pulseaudio/pulseaudio/issues/766">is a bug with Nvidia's HDMI alsa drivers</a> that prevents
pulseaudio from redetecting most of my sound interfaces on s3
resume from suspend. The usual work around is to either unplug my
HDMI output or keep killing pulseaudio until it magically works.</li>
</ul>

<p>
With AMD on the other hand I don't foresee most of these
issues. Presently I found s3 suspend-resume cycles take up to a
minute, so I need to address that. Video tearing on the other hand
is very minimal; I have been able to watch this YouTube <a href="https://www.youtube.com/watch?v=MfL_JkcEFbE">tearing test</a>
and experience no video tearing. I did notice tearing in certain
parts of Firewatch though. That is likely because Firewatch is not
particularly well optimized.
</p>
</div>
</div>


<div id="outline-container-org220cdbb" class="outline-3">
<h3 id="org220cdbb">Gotchas switching cards</h3>
<div class="outline-text-3" id="text-org220cdbb">
<p>
The GPU arrived Thursday, and I got super excited, and neglected to
run an <code>emerge -uDU --changed-deps -av @word</code> after an <code>emerge
   --sync</code>. The card installed fine, but X would segfault. I noticed
in the Xorg logs it couldn't open the <code>radeonsi</code> driver. I thought
I could simply add <code>amdgpu</code> to <code>VIDEO_CARDS</code>, but as the logs
suggest, I need <code>radeonsi</code> and <code>amdgpu</code>. <a href="https://wiki.gentoo.org/wiki/AMDGPU#Feature_support">The Gentoo Wiki also
suggests this</a>. Because I was both trying to update and reconfigure
my installation, this yielded to problems with blockers. It seemed
nvidia was the problem, as it was masking Xorg versions I needed. I
nuked <code>nvidia</code> from my <code>VIDEO_CARDS</code> and was successful in updating
and reconfiguring my graphics stack.
</p>

<p>
Additionally, <a href="https://wiki.gentoo.org/wiki/Vulkan">it appears the <code>vulkan</code> USE flag must be enabled on
<code>media-libs/mesa</code> for some Steam games to work</a>, such as The Talos
Principle. I think the Nvidia binary drivers support vulkan out of
the box, hence I never had to set a USE flag on the previous GPU
driver.
</p>

<p>
Finally, I had to configure mpv to not use vdpau (I had
forced mpv to use vdpau, for my Nvidia card). Otherwise mpv would
give me a black screen.
</p>
</div>
</div>
</div>

<div id="outline-container-orga277c32" class="outline-2">
<h2 id="orga277c32">Schoolwork</h2>
<div class="outline-text-2" id="text-orga277c32">
<p>
I found using a graphics tablet to be valuable to my math class. I
can take notes in <a href="http://xournal.sourceforge.net/">xournal</a>, and write problems step by step. You
might wonder what's wrong with paper, but it seems when in front of
a computer watching lectures and interacting with online learning
management systems, it is difficult to split attention between the
computer and the notebook. As such I simply decided to digitize the
notebook.
</p>

<p>
To make the experience more tolerable, I have been using
<a href="https://ytdl-org.github.io/youtube-dl/index.html"><code>youtube-dl</code></a> to grab all the videos I can, and play them locally in
<a href="https://mpv.io/">MPV</a>. This ensures I have global multimedia shortcuts to control
video playback, have better control over frame advance, do not
require internet access 24/7, and have better control over playback
speed.
</p>

<p>
As I finally packaged the software used for one of my classes I can
do all that class's work locally except for submission. This is
fantastic because I can use my Emacs 26 setup and do not require a
24/7 Internet connection.
</p>

<p>
My office is located in a room that can get down to the low 60°'s at
night, and I found many times I'd want to do work, I could barely
focus because I was so unevenly cold. The floor would be 60-65 but
the room would be 70. I feel like an old man complaining about this,
but really getting a space heater did wonders for my productivity
and focus. This is a schoolwork problem, because it's the most
tedious sort of productivity.
</p>
</div>
</div>

<div id="outline-container-orgf28aa12" class="outline-2">
<h2 id="orgf28aa12">Conclusion</h2>
<div class="outline-text-2" id="text-orgf28aa12">
<p>
This has been a rather long post. I really wanted to describe some
of the things I've been up to, and some of the challenges I've been
facing. I am very happy to have removed my workstation Nvidia
dependency. I am very excited about graduating soon, and adjusting
in this time, and keeping that in mind, has been a challenge. As
usual packaging software and fixing keeps my computers usable and
maintainable.
</p>

<p>
I hope to write more in the near future. I had started some posts on
debugging a GTK bug, and some other topics, but the amount of
material to cover kept growing, much like this post keeps
growing. Stay tuned to read about seccomp madness.
</p>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
See my overlay <a href="https://github.com/winny-/winny-overlay">on GitHub</a>.
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-lifestyle.html">lifestyle</a> <a href="tag-gentoo.html">gentoo</a> <a href="tag-computing.html">computing</a> </div>
<div class="post-date">25 Dec 2019</div><h1 class="post-title"><a href="2019-12-25-how-to-fix-early-framebuffer-problems,-or-can-i-type-my-disk-password-yet.html">How to fix early framebuffer problems, or "Can I type my disk password yet??"</a></h1>
<p>
Most of my workstations &amp; laptops require a passphrase typed in to
open the encrypted root filesystem. So my steps to booting are as
follows:
</p>

<ol class="org-ol">
<li>Power on machine</li>
<li>Wait for FDE passphrase prompt</li>
<li>Type in FDE passphrase</li>
<li>Wait for boot to complete and automatic XFCE session to start</li>
</ol>

<p>
Since I need to know when the computer is ready to accept the
passphrase, it is important the framebuffer is usable during the early
part of the boot. In the case of of HP Elitebook 820 G4, the EFI
framebuffer does not appear to work, and I rather not boot in BIOS
mode to get a functional VESA framebuffer. Making things more awkward,
a firmware is needed when the i915 driver is loaded, or the
framebuffer will not work either. (It&rsquo;s not always clear if a firmware
is needed, so one should run <code>dmesg | grep -F firmware</code> and check if
firmware is being loaded.)
</p>

<p>
With this information, the problem is summarized to: <b>&ldquo;How do I ensure
i915 is available at boot with the appropriate firmware?&rdquo;</b>. This
question can be easily generalized to any framebuffer driver, as the
steps are more-or-less the same.
</p>

<div id="outline-container-orgef8c42e" class="outline-2">
<h2 id="orgef8c42e">Zeroth step: Do you need only a driver, or a driver with firmware?</h2>
<div class="outline-text-2" id="text-orgef8c42e">
<p>
IT is a good idea to verify if your kernel is missing a driver at
boot, or is missing firmware or both. Boot up a Live USB with good
hardware compatibility, such as <a href="http://grml.org/">GRML</a><sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup> or Ubuntu&rsquo;s, and let&rsquo;s see what
framebuffer driver our host is trying to use<sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup>:
</p>

<pre class="example">
$ dmesg | grep -i 'frame.*buffer'
[    4.790570] efifb: framebuffer at 0xe0000000, using 8128k, total 8128k
[    4.790611] fb0: EFI VGA frame buffer device
[    4.820637] Console: switching to colour frame buffer device 240x67
[    6.643895] i915 0000:00:02.0: fb1: i915drmfb frame buffer device
</pre>

<p>
Se we can see the efifb is initially used for a couple seconds, then
i915 is used for the rest of the computer&rsquo;s uptime. Now let&rsquo;s look
at if firmware is necessary, first checking if <code>modinfo(8)</code> knows of
any firmware:
</p>

<pre class="example">
$ modinfo i915 -F firmware
i915/bxt_dmc_ver1_07.bin
i915/skl_dmc_ver1_27.bin
i915/kbl_dmc_ver1_04.bin
... SNIP ...
i915/kbl_guc_33.0.0.bin
i915/icl_huc_ver8_4_3238.bin
i915/icl_guc_33.0.0.bin
</pre>

<p>
This indicates this driver will load firmware when available, and if
necessary for the particular mode of operation or hardware.
</p>

<p>
Now let&rsquo;s look at dmesg to see if any firmware is loaded:
</p>

<pre class="example">
[    0.222906] Spectre V2 : Enabling Restricted Speculation for firmware calls
[    5.511731] [drm] Finished loading DMC firmware i915/kbl_dmc_ver1_04.bin (v1.4)
[   25.579703] iwlwifi 0000:02:00.0: loaded firmware version 36.77d01142.0 op_mode iwlmvm
[   25.612759] Bluetooth: hci0: Minimum firmware build 1 week 10 2014
[   25.620251] Bluetooth: hci0: Found device firmware: intel/ibt-12-16.sfi
[   25.712793] iwlwifi 0000:02:00.0: Allocated 0x00400000 bytes for firmware monitor.
[   27.042080] Bluetooth: hci0: Waiting for firmware download to complete
</pre>

<p>
Aha! So it appears we need <code>i915/kbl_dmc_ver1_04.bin</code> for i915. In
the case case one doesn&rsquo;t need firmware, it won&rsquo;t show anything
related to <code>drm</code> or a line with your driver name in it.
</p>

<p>
By the way, it is a good idea to check dmesg for hints about missing
firmware, or alternative drivers, for example my trackpad is
supported by both i2c and synaptics based trackpad drivers, and the
kernel was kind enough to tell me.
</p>
</div>
</div>

<div id="outline-container-orgb1e58d1" class="outline-2">
<h2 id="orgb1e58d1">First step: Obtain the firmware</h2>
<div class="outline-text-2" id="text-orgb1e58d1">
<p>
On Gentoo install
<code>sys-kernel/linux-firmware</code>. You will have to agree to some non-free
licenses; nothing too inane, but worth mentioning. Now just
run <code>emerge -av sys-kernel/linux-firmware</code>. (On other distros it
might be this easy, or more difficult; for example—in my experience
Debian does not ship every single firmware like Gentoo does, so
YMMV.)
</p>
</div>
</div>

<div id="outline-container-org1ef4c3f" class="outline-2">
<h2 id="org1ef4c3f">Second step, Option A: Compile firmware into your kernel</h2>
<div class="outline-text-2" id="text-org1ef4c3f">
<p>
Since most of my systems run Gentoo, it is business as usual to
deploy a kernel with most excess drivers disabled except for common
hot-swappable components such as USB network interfaces, audio
devices, and so on. For example, this laptop&rsquo;s config was originally
derived from genkernel&rsquo; stock amd64 config with most extra drivers
disabled, then augmented with support for an Acer ES1-111M-C7DE,
and finally with support for this Elitebook.
</p>

<p>
I had compiled the kernel with i915 support built into the image, as
opposed to an additional kernel module. Unfortunately this meant the
kernel is unable to load firmware from filesystem, because it
appears only kernel modules can load firmware from filesystem. To
work around this without resorting to making i915 a kernel module,
we can include the drivers within the kernel image (<code>vmlinuz</code>).
Including firmware and drivers both in the vmlinuz has a couple
benefits. First it will always be available. There is no need to
figure out how to load the driver and firmware from initrd, let
alone getting the initrd generator one is using, to cooperate. A
downside is it makes the kernel very specific to the machine,
because perhaps a different Intel machine needs a different firmware
file compiled in.
</p>

<p>
To achieve including the firmware in kernel, I set the following
values in my kernel config (<code>.config</code> in your kernel source tree).
</p>

<pre class="example">
CONFIG_EXTRA_FIRMWARE="i915/kbl_dmc_ver1_04.bin"
CONFIG_EXTRA_FIRMWARE_DIR="/lib/firmware"
</pre>

<p>
Note, if you&rsquo;re using menuconfig, you can type <code>/EXTRA_FIRMWARE</code>
(slash for search, then the text) followed by keyboard return to
find where these settings exist in the menu system.
</p>

<p>
Then I verified i915 is indeed not a kernel module, but built into
the kernel image (it would be <code>m</code> if it&rsquo;s a module):
</p>

<pre class="example">
CONFIG_DRM_I915=y
</pre>

<p>
After compiling &amp; installing the kernel (and generating a dracut
initrd for cryptsetup/lvm), I was able to reboot and get an early
pre-mounted-root framebuffer on this device.
</p>
</div>
</div>

<div id="outline-container-org9bf3a83" class="outline-2">
<h2 id="org9bf3a83">Second step, Option B: A portable kernel approach (using <code>sys-kernel/vanilla-kernel</code>)</h2>
<div class="outline-text-2" id="text-org9bf3a83">
<p>
I discovered the Gentoo devs <a href="https://blogs.gentoo.org/mgorny/2019/12/19/a-distribution-kernel-for-gentoo/">have begun shipping an ebuild that
builds and installs a kernel with a portable, livecd friendly
config</a>. In addition this package will optionally generates an initrd
with dracut as a pkg<sub>postinst</sub> step, making it very suitable as a
replacement for users who just want a working kernel, and don&rsquo;t mind
a excessive compatibility (at a cost to size and build time).
</p>

<p>
This presents a different challenge, because while this package does
allow the user to drop in their own .config, it is not very
multiple-machine-deployment friendly to hard-code each individual
firmware into the kernel. Instead we tell dracut to include our
framebuffer driver. As mentioned above I found this computer uses
the <code>i915</code> kernel driver for framebuffer. Let&rsquo;s tell dracut to
include the driver:
</p>

<pre class="example">
cat &gt; /etc/dracut.conf.d/i915.conf &lt;&lt;EOF
add_drivers+=" i915 "
EOF
</pre>

<p>
Dracut is smart enough to pick up the firmware the kernel module
needs, provided they are installed. To get an idea what firmware
dracut will include, run <code>modinfo i915 -F firmware</code> which will print
out a bunch of firmware relative paths.
</p>

<p>
After applying this fix, just regenerate your initrd using dracut; in
my case I let portage do the work:
<code>emerge -1av sys-kernel/vanilla-kernel</code>. Finally reboot.
</p>
</div>
</div>

<div id="outline-container-org59fae8f" class="outline-2">
<h2 id="org59fae8f">Conclusion</h2>
<div class="outline-text-2" id="text-org59fae8f">
<p>
Check dmesg. Always check dmesg. We found two ways to deploy
firmware, in-kernel and in-initrd. The in-kernel technique is best
for a device-specific kernel, the in-initrd is best for a portable
kernel. I am a big fan of the second technique because it scales
well to many machines.
</p>

<p>
I did not touch on the political side of using binary blobs. It
would be nice to not use any non-free software, but I rather have a
working system with a couple small non-free components, than a
non-working system. Which is more valuable, your freedom, or reduced
capacity of your tools?
</p>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
GRML is my favorite live media. It is simple, to the point, has
lots of little scripts to streamline tasks such as setting up a
wireless AP, a iPXE netboot environment, a router, installing debian,
and so on. And Remastering is relatively straight forward. It also has
a sane gui sutable for any machine (fluxbox).
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
Thanks to <a href="https://askubuntu.com/questions/727577/how-to-check-if-framebuffer-is-enabled">this post</a> on Ask Ubuntu
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-gentoo.html">gentoo</a> <a href="tag-linux.html">linux</a> <a href="tag-computing.html">computing</a> </div>
<div class="post-date">28 Jul 2019</div><h1 class="post-title"><a href="2019-07-28-open-url-in-existing-qutebrowser-from-emacs-daemon-on-gentoo.html">Open URL in existing Qutebrowser from Emacs Daemon on Gentoo</a></h1>
<p>
On my Gentoo desktops, I use Emacs Daemon via <code>sys-emacs/emacs-daemon</code><sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup>
to ensure an Emacs instance is ready to go and always available from
boot. This is done via creating a symbolic link like
<code>/etc/init.d/emacs.winston</code> to <code>/etc/init.d/emacs</code> which will start Emacs
for the given user. See the package README for more details.
</p>

<p>
A shortcoming of this setup is <code>XDG_RUNTIME_DIR</code><sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup> is not set, as this is
set by my Desktop Session - maybe LightDM or consolekit set this? As a
result, when I open a URL from Emacs Daemon, it opens a fresh
qutebrowser session, loading the saved default session, and making a
mess of my workflow.
</p>

<p>
One approach to fix this might be to instead run Emacs daemon from my
<code>.xsession</code> script, but I rather not supervise daemons at the user
level; if I were to consider this, I'd be better off to switch to
systemd for user-level services anyway.
</p>

<p>
The solution I came up with is to add some lines to my <code>init.el</code> to
ensure <code>XDG_RUNTIME_DIR</code> is set to the expected value:
</p>

<div class="org-src-container">
<pre class="src src-emacs-lisp">(<span style="color: #4c83ff;">defun</span> <span style="color: #ff1493;">winny/ensure-XDG_RUNTIME_DIR</span> ()
  <span style="color: #FBDE2D;">"Ensure XDG_RUNTIME_DIR is set. Used by qutebrowser and other utilities."</span>
  (<span style="color: #4c83ff;">let</span> ((rd (getenv <span style="color: #61CE3C;">"XDG_RUNTIME_DIR"</span>)))
    (<span style="color: #4c83ff;">when</span> (<span style="color: #4c83ff;">or</span> (not rd) (string-empty-p rd))
      (setenv <span style="color: #61CE3C;">"XDG_RUNTIME_DIR"</span> (format <span style="color: #61CE3C;">"/run/user/%d"</span> (user-uid))))))

(add-hook 'after-init-hook #'winny/ensure-XDG_RUNTIME_DIR)
</pre>
</div>

<p>
A strange emacs-ism: <code>(user-uid)</code> returns float or integer, despite the
backing <code>uid_t</code> (on *nix) is guarenteed to be an integer type. I'll just
assume this'll never return a float. Please contact me otherwise, I'd
love to hear about this.
</p>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
<a href="https://packages.gentoo.org/packages/app-emacs/emacs-daemon">https://packages.gentoo.org/packages/app-emacs/emacs-daemon</a>
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
<a href="https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html">freedesktop.org XDG Base Directory Specification</a>
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-emacs.html">emacs</a> <a href="tag-productivity.html">productivity</a> <a href="tag-computing.html">computing</a> <a href="tag-gentoo.html">gentoo</a> <a href="tag-qutebrowser.html">qutebrowser</a> </div><div id="archive">
<a href="archive.html">Other posts</a>
</div>
</div>
<div id="postamble" class="status">
<hr/>
<ul class="inline-list interpunct">
<li>Powered by <a href="https://github.com/bastibe/org-static-blog">org-static-blog</a></li>
<li>Like what I do? <a href="https://www.buymeacoffee.com/winny">Buy me a Coffee</a></li>
</ul>
<p>© Winston Weinert (winny) — <a href="https://creativecommons.org/licenses/by-sa/4.0/legalcode">CC-BY-SA-4.0</a></p>
</div>
</body>
</html>
